﻿
Imports System.IO
Imports System.Text
Public Class Form1


    Private Sub Form_Load(sender As Object, e As EventArgs) Handles Me.Load
        Label_1.ForeColor = Color.Red
        Label_2.ForeColor = Color.Red
        Label_3.ForeColor = Color.Red
        Label_4.ForeColor = Color.Red
    End Sub



    ''' <summary>
    ''' Pfad festlegen, 2 Dateien im Ordner erstellen, und alle vorhandenen Dateien in ListBox1 schreiben und den Pfad in das Label 'LabelSelectedPath' schreiben
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonPfadSuchen_Click(sender As Object, e As EventArgs) Handles ButtonPfadSuchen.Click
        Dim FolderBrowserDialog1 As New FolderBrowserDialog
        Dim dlgResult As DialogResult

        dlgResult = FolderBrowserDialog1.ShowDialog()
        If dlgResult = DialogResult.Cancel Then
            MessageBox.Show("Dialog was cancelled")
        Else
            LabelSelectedPath.Text = FolderBrowserDialog1.SelectedPath

            LegeDateienAn(FolderBrowserDialog1.SelectedPath)
            If GibtEsFremdeDateien(FolderBrowserDialog1.SelectedPath) = False Then
                MsgBox("Bitte zuerst 2 '*.txt Dateien' im ausgewählten Ordner anlegen!" & vbCrLf & "Eine mit, eine ohne Umlaute." & vbCrLf & "Dann noch mal anklicken!")
                Exit Sub
            End If


            ListBox1.Tag = FolderBrowserDialog1.SelectedPath
            'Files ohne Endung: IO.Path.GetFileNameWithoutExtension
            For Each a As String In IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath)
                Dim fi As New IO.FileInfo(a)
                ListBox1.Items.Add(fi.Name)
            Next
        End If

    End Sub





    ''' <summary>
    ''' es werden 2 txt-Dateien angelegt, eine mit, eine ohne Umlaut
    ''' </summary>
    ''' <param name="path"></param>
    Private Sub LegeDateienAn(path As String)
        'Dim Datei As String = path & "\MyTest.txt"

        '' Create or overwrite the file.
        'Dim fs As FileStream = File.Create(path)
        'fs.Close()
        File.WriteAllText(path & "\" & "EigenTest.txt", "")
        File.WriteAllText(path & "\" & "EigenTestÜ.txt", "")

    End Sub



    ''' <summary>
    ''' Es wird getestet ob in dem ausgewählten Ordner auch txt-Files sind die nicht von diesem Programm angelegt wurden.
    ''' </summary>
    ''' <param name="Path">Der Pfad zum Ordner</param>
    ''' <returns></returns>
    Private Function GibtEsFremdeDateien(Path As String) As Boolean
        Dim EigeneFiles() As String
        Dim AlleFiles() As String

        EigeneFiles = Directory.GetFiles(Path, "Eigen*.txt")
        AlleFiles = Directory.GetFiles(Path, "*.txt")
        If EigeneFiles.Length = 2 AndAlso (AlleFiles.Length - EigeneFiles.Length > 0) Then
            Return True
        End If

        Return False


    End Function





    ''' <summary>
    ''' Die in der Listbox selectierte Datei wird mittels 'IO.Directory.GetFiles' gesucht. Datei Extension wird entfernt und '.*' an den Dateinamen angefügt
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonMitGetFilesmitWildcardSuchen_Click(sender As Object, e As EventArgs) Handles ButtonMitGetFilesmitWildcardSuchen.Click
        Dim GefundeneDateien() As String
        Dim VollständigerDateiname As String = ""
        Dim DateiOhneExtension As String = ""

        'Wenn keine Datei ausgewählt ist, kann nix gesucht werden
        If ListBox1.SelectedItems.Count = 0 Then
            MsgBox("Bitte zuerst die zu suchende Datei auswählen!")
            Exit Sub
        End If

        'extension entfernen
        Dim txt As String = ListBox1.SelectedItem.ToString
        Dim teil() As String
        teil = txt.Split("."c)
        DateiOhneExtension = teil(0)

        'Die Dateien raussuchen
        GefundeneDateien = IO.Directory.GetFiles(ListBox1.Tag.ToString, DateiOhneExtension & ".*")

        'Meldung ausgeben
        VollständigerDateiname = LabelSelectedPath.Text & "\" & DateiOhneExtension & ".*"
        If GefundeneDateien.Length > 0 Then
            MessageBox.Show("Die Datei '" & VollständigerDateiname & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  gefunden!")
        Else
            MessageBox.Show("Die Datei: '" & VollständigerDateiname & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  NICHT gefunden!")
        End If
    End Sub



    ''' <summary>
    ''' Die in der Listbox selectierte Datei wird mittels 'IO.Directory.GetFiles' gesucht. Mit Dateinamen und vollständiger Extension
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonGETFilesOHNEWildcard_Click(sender As Object, e As EventArgs) Handles ButtonGETFilesOHNEWildcard.Click
        Dim GefundeneDateien() As String
        Dim VollständigerDateiname As String = ""

        'Wenn keine Datei ausgewählt ist, kann nix gesucht werden
        If ListBox1.SelectedItems.Count = 0 Then
            MsgBox("Bitte zuerst die zu suchende Datei auswählen!")
            Exit Sub
        End If

        'Die Dateien raussuchen
        GefundeneDateien = IO.Directory.GetFiles(ListBox1.Tag.ToString, ListBox1.SelectedItem.ToString)

        'Meldung ausgeben
        VollständigerDateiname = ListBox1.Tag.ToString & "\" & ListBox1.SelectedItem.ToString
        If GefundeneDateien.Length > 0 Then
            MessageBox.Show("Die Datei '" & VollständigerDateiname & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  gefunden!")
        Else
            MessageBox.Show("Die Datei: '" & VollständigerDateiname & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  NICHT gefunden!")
        End If


    End Sub




    ''' <summary>
    ''' Die in der Listbox selectierte Datei wird mittels 'FileSystem.FileExists' gesucht. Vollständiger Dateiename und Extension. 
    ''' Denn Wildcard funktioniert nicht bei FileExists
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonFileExistsSuche_Click(sender As Object, e As EventArgs) Handles ButtonFileExistsSuche.Click
        Dim Zusuchen As String = ""

        'Wenn keine Datei ausgewählt ist, kann nix gesucht werden
        If ListBox1.SelectedItems.Count = 0 Then
            MsgBox("Bitte zuerst die zu suchende Datei auswählen!")
            Exit Sub
        End If
        Zusuchen = ListBox1.Tag.ToString & "\" & ListBox1.SelectedItem.ToString

        If My.Computer.FileSystem.FileExists(Zusuchen) Then
            MessageBox.Show("Die Datei: '" & Zusuchen & "'" & vbCrLf & "wurde mit 'FileSystem.FileExists'  gefunden!")
        Else
            MessageBox.Show("Die Datei: '" & Zusuchen & "'" & vbCrLf & "wurde mit 'FileSystem.FileExists'  NICHT gefunden!")
        End If

    End Sub


    ''' <summary>
    ''' es werden alle Dateien mit der Function IO.Directory.GetFiles  gesucht die auf *.* passen, also eigentlich alle vorhandenen Dateien
    ''' es werden alle zurückgegeben, auch die mit Umlauten
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonSuchenGetFiles_Click(sender As Object, e As EventArgs) Handles ButtonSuchenGetFiles.Click
        Dim GefundeneDateien() As String
        Dim VollständigerDateiname As String = ""

        If LabelSelectedPath.Text = "Pfad zum NAS" Then
            MsgBox("Bitte zuerst Pfad zum NAS festlegen!")
            Exit Sub
        End If


        'Die Dateien raussuchen
        GefundeneDateien = IO.Directory.GetFiles(ListBox1.Tag.ToString, "*.*")

        'Meldung ausgeben
        VollständigerDateiname = LabelSelectedPath.Text & "\" & "*.*"
        If GefundeneDateien.Length > 0 Then
            For Each a As String In GefundeneDateien
                ListBox2.Items.Add(a)
            Next
        Else
            MessageBox.Show("Es wurden KEINE Dateien gefunden!")
        End If
    End Sub


    ''' <summary>
    ''' es werden alle Dateien mit der Function IO.Directory.GetFiles  gesucht die auf *.txt passen, also eigentlich alle vorhandenen Dateien
    ''' es werden alle Text-Dateien zurückgegeben, auch die mit Umlauen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonsuchenWildcardTXT_Click(sender As Object, e As EventArgs) Handles ButtonsuchenWildcardTXT.Click
        Dim GefundeneDateien() As String
        Dim VollständigerDateiname As String = ""

        If LabelSelectedPath.Text = "Pfad zum NAS" Then
            MsgBox("Bitte zuerst Pfad zum NAS festlegen!")
            Exit Sub
        End If


        'Die Dateien raussuchen
        GefundeneDateien = IO.Directory.GetFiles(ListBox1.Tag.ToString, "*.txt")

        'Meldung ausgeben
        VollständigerDateiname = LabelSelectedPath.Text & "\" & "txt.*"
        If GefundeneDateien.Length > 0 Then
            For Each a As String In GefundeneDateien
                ListBox3.Items.Add(a)
            Next
        Else
            MessageBox.Show("Es wurden KEINE Dateien gefunden!")
        End If
    End Sub


    ''' <summary>
    ''' Die in der Listbox selectierte Datei wird mittels 'FileSystem.FileExists' gesucht. Datei-Extension wird durch '*' ersetzt. Umlaut 'ü' wird durch '*' ersetzt
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub ButtonÜersetzen_Click(sender As Object, e As EventArgs) Handles ButtonÜersetzen.Click
        Dim GefundeneDateien() As String
        Dim VollständigerDateiname As String = ""
        Dim DateiOhneExtension As String = ""

        'Wenn keine Datei ausgewählt ist, kann nix gesucht werden
        If ListBox1.SelectedItems.Count = 0 Then
            MsgBox("Bitte zuerst die zu suchende Datei auswählen!")
            Exit Sub
        End If

        'extension entfernen
        Dim txt As String = ListBox1.SelectedItem.ToString
        Dim teil() As String
        teil = txt.Split("."c)
        DateiOhneExtension = teil(0)

        DateiOhneExtension = DateiOhneExtension.Replace("ü", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("Ü", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("ä", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("Ä", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("ö", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("Ö", "*")
        DateiOhneExtension = DateiOhneExtension.Replace("ß", "*")



        'Die Dateien raussuchen
        GefundeneDateien = IO.Directory.GetFiles(ListBox1.Tag.ToString, DateiOhneExtension & ".*")

        'Meldung ausgeben
        VollständigerDateiname = LabelSelectedPath.Text & "\" & DateiOhneExtension & ".*"
        If GefundeneDateien.Length > 0 Then
            MessageBox.Show("Die Datei '" & DateiOhneExtension & ".*" & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  gefunden!")
        Else
            MessageBox.Show("Die Datei: '" & DateiOhneExtension & ".*" & "'" & vbCrLf & "wurde mit 'Directory.GetFiles'  NICHT gefunden!")
        End If
    End Sub




End Class
